//=============================================================================
// CustomizeMessageWindow.js
// ----------------------------------------------------------------------------
// Copyright (c) 2015-2016 Triacontane
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// Version
// 1.0.0 2016/12/15 初版
// ----------------------------------------------------------------------------
// [Blog]   : http://triacontane.blogspot.jp/
// [Twitter]: https://twitter.com/triacontane/
// [GitHub] : https://github.com/triacontane/
//=============================================================================

/*:
 * @plugindesc CustomizeMessageWindowPlugin
 * @author triacontane
 *
 * @help 顔グラフィックがメッセージウィンドウの
 * 右側に表示されるようになります。
 *
 * このプラグインにはプラグインコマンドはありません。
 *
 * Plugin Command
 *  XXXXX [XXX]
 *  ex1：XXXXX 1
 *
 * This plugin is released under the MIT License.
 */
/*:ja
 * @plugindesc 顔グラフィック表示位置変更プラグイン
 * @author トリアコンタン
 *
 * @help 顔グラフィックがメッセージウィンドウの
 * 右側に表示されるようになります。
 *
 * このプラグインにはプラグインコマンドはありません。
 *
 * 利用規約：
 *  作者に無断で改変、再配布が可能で、利用形態（商用、18禁利用等）
 *  についても制限はありません。
 *  このプラグインはもうあなたのものです。
 */

(function () {
  "use strict";

  Window_Message.prototype.drawMessageFace = function () {
    if (!$gameSwitches.value(1168)) {
      if (!$gameSwitches.value(1048)) {
        $gameSwitches.setValue(1049, true);
      }
    }

    if (!$gameSwitches.value(1050)) {
      $gameSwitches.setValue(1050, true);
    }

    if (!$gameMessage.faceName()) {
      return;
    }

    var faceName = $gameMessage.faceName();
    var faceIndex = $gameMessage.faceIndex();

    //立ち絵コモンイベント設定
    switch (faceName) {
      case "_Kuroa1":
        $gameVariables.setValue(115, 200 + faceIndex);
        break;
      case "_Kuroa2":
        $gameVariables.setValue(115, 208 + faceIndex);
        break;
      case "_Kuroa3":
        $gameVariables.setValue(115, 216 + faceIndex);
        break;
      case "_Kuroa4":
        $gameVariables.setValue(115, 224 + faceIndex);
        break;
      case "_Kuroa5":
        $gameVariables.setValue(115, 232 + faceIndex);
        break;
      case "_Kuroa6":
        $gameVariables.setValue(115, 240 + faceIndex);
        break;
      case "_KuroaS1":
        $gameVariables.setValue(115, 200 + faceIndex);
        break;
      case "_KuroaS2":
        $gameVariables.setValue(115, 208 + faceIndex);
        break;
      case "_KuroaS3":
        $gameVariables.setValue(115, 216 + faceIndex);
        break;
      case "_KuroaS4":
        $gameVariables.setValue(115, 224 + faceIndex);
        break;
      case "_KuroaS5":
        $gameVariables.setValue(115, 232 + faceIndex);
        break;
      case "_KuroaS6":
        $gameVariables.setValue(115, 240 + faceIndex);
        break;
      case "_KuroaB1":
        $gameVariables.setValue(115, 262 + faceIndex);
        break;
      case "DummyFace":
        $gameVariables.setValue(115, 300);
        break;
      case "Aroma1":
        $gameVariables.setValue(115, 282 + faceIndex);
        break;
      case "Aroma2":
        $gameVariables.setValue(115, 290 + faceIndex);
        break;
      case "Aroma3":
        $gameVariables.setValue(115, 298 + faceIndex);
        break;
      case "Aroma4":
        $gameVariables.setValue(115, 306 + faceIndex);
        break;
      case "_ダルトン":
        $gameMessage.add("選択肢３を選択");
        break;
      default:
        return;
        break;
    }
    //立ち絵コモンイベント呼び出し
    $gameSwitches.setValue($gameVariables.value(115), true);
  };

  Window_Message.prototype.newLineX = function () {
    return 0;
  };
})();
/*
Window_Base.prototype.lineHeight = function() {
	return 40;
};
*/

//YEP_MessageCore.js this.x 変更
(function () {
  "use strict";

  var _Window_Message_updatePlacement =
    Window_Message.prototype.updatePlacement;
  Window_Message.prototype.updatePlacement = function () {
    _Window_Message_updatePlacement.apply(this, arguments);
    this.x = 0;
  };
})();

/*
Bitmap.prototype._drawTextOutline = function(text, tx, ty, maxWidth) {
    var context = this._context;
    context.strokeStyle = this.outlineColor;
    context.lineWidth = 8;
    context.lineJoin = 'round';
    context.strokeText(text, tx, ty, maxWidth);
};
*/
//メッセージアウトライン太さ
/*
(function () {
    'use strict';
    var _Window_Base_createContents = Window_Base.prototype.createContents;
    Window_Base.prototype.createContents = function() {
        _Window_Base_createContents.apply(this, arguments);
        this.contents.outlineColor = 'black';
        this.contents.outlineWidth = 10;
    };
})();
*/

/*
(function() {

  var parameters = PluginManager.parameters('ALT_MessageOutline');
  var paramOutlineSize = Number(parameters['アウトラインの太さ'] || '4');

  var Window_Message_resetFontSettings = Window_Base.prototype.resetFontSettings;
  Window_Message.prototype.resetFontSettings = function() {
    Window_Message_resetFontSettings.call(this);
    this.contents.outlineWidth = paramOutlineSize;
  };

})();	
*/

/*
Window.prototype._refreshPauseSign = function() {
var sx = 144;
var sy = 96;
var p = 24;
this.contentsOpacity = 255;//不透明度を設定255→125で半透明
this._windowPauseSignSprite.bitmap = this._windowskin;
this._windowPauseSignSprite.anchor.x = 0.5;
this._windowPauseSignSprite.anchor.y = 1;
this._windowPauseSignSprite.move(this._width / 2, this._height);
this._windowPauseSignSprite.setFrame(sx, sy, p, p);
this._windowPauseSignSprite.alpha = 0;
};
*/

//メッセージウインドウの位置
Window_Message.prototype.updatePlacement = function () {
  this._positionType = $gameMessage.positionType();
  this.y = (this._positionType * (Graphics.boxHeight - this.height)) / 2;
  this._goldWindow.y =
    this.y > 0 ? 0 : Graphics.boxHeight - this._goldWindow.height;
  var x = 284; //224 220
  var y = 54; //68 57
  if ($gameSwitches.value(1168)) {
    if ($gameSwitches.value(1170)) {
      //戦闘モード リザルト画面
      x = 80; //80
      y = 150; //150
    } else {
      x = 130; //80
      y = 180; //150
    }
  } else if ($gameSwitches.value(9)) {
    //●Mウインドウ透過
    y = 30;
    if ($gameVariables.value(707) == 0) {
      x = 300; //180 300
    } else if ($gameVariables.value(707) == 1) {
      x = 180; //180 300
    }
  } else if ($gameSwitches.value(10)) {
    //●Mウィンドウ左寄り
    x = 84;
    y = 60;
  }

  if (this._positionType === 2) this.y -= y;
  this.x = x;
  //console.log(this.x);
};

//})();

//メッセージウインドウの幅
Window_Message.prototype.windowWidth = function () {
  if ($gameSwitches.value(1168)) {
    //console.log(3333333333);

    return Graphics.boxWidth - 100;
  } else if ($gameSwitches.value(357)) {
    return Graphics.boxWidth - 550;
  } else {
    //console.log(1111111112222222);

    return Graphics.boxWidth - 380; //466 370 365 300
  }
};

Window_Message.prototype.numVisibleRows = function () {
  if ($gameSwitches.value(1168)) {
    return 4;
  } else {
    return 4;
  }
};

// コモンイベント発動用のなにもしないスキルは、光る演出をなくす
Game_Enemy.prototype.performActionStart = function (action) {
  if (typeof action.item().meta.NoneSkill === "undefined") {
    Game_Battler.prototype.performActionStart.call(this, action);
    this.requestEffect("whiten");
  }
};

// コモンイベント発動用のなにもしないスキルは、メッセージログのウェイトをなくす
Window_BattleLog.prototype.displayAction = function (subject, item) {
  var numMethods = this._methods.length;
  if (DataManager.isSkill(item)) {
    if (item.message1) {
      this.push("addText", subject.name() + ': ' + item.message1.format(item.name));
    }
    if (item.message2) {
      this.push("addText", item.message2.format(item.name));
    }
  } else {
    this.push("addText", TextManager.useItem.format(subject.name(), item.name));
  }
  if (this._methods.length === numMethods && !item.meta.NoneSkill) {
    this.push("wait");
  }
};
//カーソル点滅速度
Window.prototype._updateCursor = function () {
  var blinkCount = this._animationCount % 60; //40
  var cursorOpacity = this.contentsOpacity;
  if (this.active) {
    if (blinkCount < 20) {
      cursorOpacity -= blinkCount * 8; //8
    } else {
      cursorOpacity -= (40 - blinkCount) * 8; //8
    }
  }
  this._windowCursorSprite.alpha = cursorOpacity / 255;
  this._windowCursorSprite.visible = this.isOpen();
};
/*//追加　メッセージウィンドウ閉じない
Window_Message.prototype.checkToNotClose = function() {
	if (this.isClosing() && this.isOpen()) {
		if (this.doesContinue() || $gameSwitches.value(54)) {
		//if (this.doesContinue()) {
			this.open();
		}else{
			$gameScreen.erasePicture(87); //メッセージウィンドウ一時消去
			$gameSwitches.setValue(1048,false);
			$gameSwitches.setValue(1050,false);
		}
	}
};
*/
//購入できなかった時
Window_ShopBuy.prototype.isCurrentItemEnabled = function () {
  if (
    !(
      this._data[this.index()] &&
      this.price(this._data[this.index()]) <= this._money &&
      !$gameParty.hasMaxItems(this._data[this.index()])
    )
  ) {
    $gameVariables.setValue(112, 2);
    //console.log(33333);
  }
  if ($gameParty.hasMaxItems(this._data[this.index()])) {
    $gameVariables.setValue(112, 4);
  }
  //console.log(33333);
  return this.isEnabled(this._data[this.index()]);
};

Window_ShopBuy.prototype.isEnabled = function (item) {
  if (
    !(item && this.price(item) <= this._money && !$gameParty.hasMaxItems(item))
  ) {
    //console.log(222222);
  }

  return (
    item && this.price(item) <= this._money && !$gameParty.hasMaxItems(item)
  );
};
//ショップ背景ぼかさない
SceneManager.snapForBackground = function () {
  this._backgroundBitmap = this.snap();
  if (!$gameSwitches.value(1082)) {
    this._backgroundBitmap.blur();
  }
};

//セーブリストのプレイタイムの字間をあける
Window_SavefileList.prototype.drawPlaytime = function (info, x, y, width) {
  if (info.playtime) {
    //var playtime = info.playtime;
    //var playtime = info.playtime.replace(/:/g,':');
    //console.log(playtime);
    this.drawText(info.playtime, x, y, width, "right");
    //this.drawText(playtime, x, y, width, 'right');
  }
};

//装備ステータス変更
Window_EquipStatus.prototype.drawItem = function (x, y, paramId) {
  this.drawParamName(x + this.textPadding(), y, paramId);
  //console.log(this._actor);
  if (this._actor) {
    this.drawCurrentParam(x + 140, y, paramId);
  }
  this.drawRightArrow(x + 188, y);
  if (this._tempActor) {
    this.drawNewParam(x + 222, y, paramId);
  }
};

/*:ja
 * @plugindesc 放置していると画面がフリーズするのを修正
 * @author kido
 *
 * @help
 * このコアスクリプトの修正を取り込みます
 * https://github.com/rpgtkoolmv/corescript/pull/191
 *
 */

(function () {
  var _render = Graphics.render;
  Graphics.render = function (stage) {
    if (this._skipCount < 0) {
      this._skipCount = 0;
    }
    _render.call(this, stage);
  };
})();
