﻿//=============================================================================
// Yanfly Engine Plugins - Button Common Events
// YEP_ButtonCommonEvents.js
//=============================================================================

var Imported = Imported || {};
Imported.YEP_ButtonCommonEvents = true;

var Yanfly = Yanfly || {};
Yanfly.BCE = Yanfly.BCE || {};
Yanfly.BCE.version = 1.02;

//=============================================================================
/*:ja
 * @plugindesc v1.02 マップ画面で特定のキーが押された時にコモンイベントを実行します
 * @author Yanfly Engine Plugins
 *
 * @param ---1行目---
 * @text ---1行目---
 * @default
 *
 * @param Key ~
 * @text キー：~
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 1
 * @text キー：1
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 2
 * @text キー：2
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 3
 * @text キー：3
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 4
 * @text キー：4
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 5
 * @text キー：5
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 6
 * @text キー：6
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 7
 * @text キー：7
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 8
 * @text キー：8
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 9
 * @text キー：9
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key 0
 * @text キー：0
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key -
 * @text キー：-
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key =
 * @text キー：=
 * @parent ---1行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param ---2行目---
 * @text ---2行目---
 * @default
 *
 * @param Key Q (PageUp)
 * @text キー：Q (PageUp)
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key W (PageDown)
 * @text キー：W (PageDown)
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key E
 * @text キー：E
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key R
 * @text キー：R
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key T
 * @text キー：T
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Y
 * @text キー：Y
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key U
 * @text キー：U
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key I
 * @text キー：I
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key O
 * @text キー：O
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key P
 * @text キー：P
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key [
 * @text キー：[
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key ]
 * @text キー：]
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key \
 * @text キー：\
 * @parent ---2行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param ---3行目---
 * @text ---3行目---
 * @default
 *
 * @param Key A
 * @text キー：A
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key S
 * @text キー：S
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key D
 * @text キー：D
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key F
 * @text キー：F
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key G
 * @text キー：G
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key H
 * @text キー：H
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key J
 * @text キー：J
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key K
 * @text キー：K
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key L
 * @text キー：L
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key ;
 * @text キー：;
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key "
 * @text キー："
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Enter (OK)
 * @text キー：Enter (OK)
 * @parent ---3行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param ---4行目---
 * @text ---4行目---
 * @default
 *
 * @param Key Shift (Dash)
 * @text キー：Shift (Dash)
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Z (OK)
 * @text キー：Z (OK)
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key X (Cancel)
 * @text キー：X (Cancel)
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key C
 * @text キー：C
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key V
 * @text キー：V
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key B
 * @text キー：B
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key N
 * @text キー：N
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key M
 * @text キー：M
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key ,
 * @text キー：,
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key .
 * @text キー：.
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key /
 * @text キー：/
 * @parent ---4行目---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param ---その他---
 * @text ---その他---
 * @default
 *
 * @param Key Space (OK)
 * @text キー：Space (OK)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Left (Left)
 * @text キー：Left (Left)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Up (Up)
 * @text キー：Up (Up)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Right (Right)
 * @text キー：Right (Right)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Down (Down)
 * @text キー：Down (Down)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Insert (Cancel)
 * @text キー：Insert (Cancel)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Delete
 * @text キー：Delete
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Home
 * @text キー：Home
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key End
 * @text キー：End
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Page Up (PageUp)
 * @text キー：Page Up (PageUp)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key Page Down (PageDown)
 * @text キー：Page Down (PageDown)
 * @parent ---その他---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param ---テンキー---
 * @text ---テンキー---
 * @default
 *
 * @param Key NumPad 0 (Cancel)
 * @text キー：NumPad 0 (Cancel)
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 1
 * @text キー：NumPad 1
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 2 (Down)
 * @text キー：NumPad 2 (Down)
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 3
 * @text キー：NumPad 3
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 4 (Left)
 * @text キー：NumPad 4 (Left)
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 5
 * @text キー：NumPad 5
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 6 (Right)
 * @text キー：NumPad 6 (Right)
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 7
 * @text キー：NumPad 7
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 8 (Up)
 * @text キー：NumPad 8 (Up)
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad 9
 * @text キー：NumPad 9
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad .
 * @text キー：NumPad .
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad +
 * @text キー：NumPad +
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad -
 * @text キー：NumPad -
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad *
 * @text キー：NumPad *
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @param Key NumPad /
 * @text キー：NumPad /
 * @parent ---テンキー---
 * @type common_event
 * @desc このキーが押された時に呼び出すコモンイベント
 * イベントを呼び出さない場合、0に設定
 * @default 0
 *
 * @help
 * 翻訳:ムノクラ
 * https://fungamemake.com/
 * https://twitter.com/munokura/
 *
 * ===========================================================================
 * 導入
 * ===========================================================================
 *
 * このプラグインを使用すると、
 * キーボード上の個々のキーにコモンイベントを関連付けることができます。
 * 標準のZをOKに、
 * Xをキャンセルにする代わりに、
 * 他のキーの動作を変えることができます。
 * 変更すべきではない重要なキーを除いて、
 * キーボードの全てでほぼ完全なアクセス権が与えられます。
 *
 * ===========================================================================
 * 説明
 * ===========================================================================
 *
 * プラグインのパラメータには、
 * コモンイベントに関連付けられる全てのキーのリストが表示されます。
 * その番号が0以外のものである場合、
 * それに関連付けられた番号が実行されるコモンイベントになります。
 * 存在しないコモンイベントIDに割り当てた場合、
 * エラーになるので注意してください。
 *
 * 括弧内にいくつかのキーの横に
 * （OK）や（Cancel）のような単語があることに気付くかもしれません。
 * これが意味することは、それらのキーが既に
 * ゲームによってそれらに割り当てられた機能を持っているということです。
 * これらのキーにコモンイベントを割り当てた場合、
 * 割り当てたコモンイベントのためにキーのネイティブ機能は削除されます。
 *
 * 下記は既に割り当てられているキーのリストです。
 *
 * キー - 割当てられているもの
 *   - Q         - 割当: PageUp
 *   - W         - 割当: PageDown
 *   - Shift     - 割当: ダッシュ
 *   - Z         - 割当: OK
 *   - X         - 割当: キャンセル
 *   - Space     - 割当: OK
 *   - Left      - 割当: 左へ移動
 *   - Up        - 割当: 上へ移動
 *   - Right     - 割当: 右へ移動
 *   - Down      - 割当: 下へ移動
 *   - Insert    - 割当: キャンセル
 *   - Page Up   - 割当: PageUp
 *   - Page Down - 割当: PageDown
 *   - Numpad 0  - 割当: キャンセル
 *   - Numpad 2  - 割当: 下へ移動
 *   - Numpad 4  - 割当: 左へ移動
 *   - Numpad 6  - 割当: 右へ移動
 *   - Numpad 8  - 割当: 上へ移動
 *
 * 繰り返しますが、これらのキーにコモンイベントを割り当てると、
 * そのコモンイベントによってそのキーが本来持っていた関連付けが削除されます。
 * ただし、これはプレイヤーがフィールドマップにいる間にのみ適用されます。
 * メニューや戦闘システムの中にいると、以前の本来の機能が回復します。
 *
 * ===========================================================================
 * 互換性の問題
 * ===========================================================================
 *
 * このプラグインには、キーストロークを変更したり、
 * 別の方法でそれらを使用するものとの互換性の問題がある可能性があります。
 * これには、KeyboardConfig.js が含まれます。
 * このプラグイン KeyboardConfig.js の改訂版が、Yanfly.moeに用意されています。
 * これがそれと互換性があるようにするために
 * YEP_KeyboardConfig Ver1.01 を持っていることを確認してください。
 * このプラグインは、2つのプラグインが連携して動作するために
 * YEP_KeyboardConfig の上に配置する必要があります。
 *
 * ===========================================================================
 * プラグインコマンド
 * ===========================================================================
 *
 * 関連付けられたコモンイベントとデフォルトボタンの間を
 * 行き来するために、下記のプラグインコマンドを使用してください。
 *
 * プラグインコマンド
 *
 *   RevertButton Ok
 *   RevertButton Cancel
 *   RevertButton Dash
 *   RevertButton PageUp
 *   RevertButton PageDown
 *   RevertButton Left
 *   RevertButton Up
 *   RevertButton Right
 *   RevertButton Down
 *   RevertButton All
 *   - 元の機能のいずれかに関連付けされている全てのキーを元のボタンに戻し、
 *   それらに関連付けされているコモンイベントの関連付けを解除します。
 *   "All"機能で元に戻すと、影響を受ける全てのボタンは元の機能に戻ります。
 *
 *   SwitchButton Ok
 *   SwitchButton Cancel
 *   SwitchButton Dash
 *   SwitchButton PageUp
 *   SwitchButton PageDown
 *   SwitchButton Left
 *   SwitchButton Up
 *   SwitchButton Right
 *   SwitchButton Down
 *   SwitchButton All
 *   - 元の機能の代わりにコモンイベント関連付けを使用するように、
 *   元の機能を持つ全てのキーを切り替えます。
 *   "All"機能で切り替えると、
 *   影響を受ける全てのボタンがそれに切り替わります。
 *
 *   TriggerButton Ok
 *   TriggerButton Cancel
 *   TriggerButton Dash
 *   TriggerButton PageUp
 *   TriggerButton PageDown
 *   TriggerButton Left
 *   TriggerButton Up
 *   TriggerButton Right
 *   TriggerButton Down
 *   - 元の機能の全てのキーにコモンイベントが関連付けされている場合、
 *   ゲームがそれらの元の機能の1つのボタンコマンドを実行するように
 *   シミュレートします。
 *
 * ===========================================================================
 * Changelog
 * ===========================================================================
 *
 * Version 1.02:
 * - Updated for RPG Maker MV version 1.5.0.
 *
 * Version 1.01:
 * - Changed buttons from triggering to repeating so that common events can
 * continuously run while being held down.
 *
 * Version 1.00:
 * - Finished Plugin!
 */
//=============================================================================
// Parameter Variables
//=============================================================================

Yanfly.Parameters = PluginManager.parameters("YEP_ButtonCommonEvents");
Yanfly.Param = Yanfly.Param || {};

Yanfly.Param.BCEList = {
  tilde: Number(Yanfly.Parameters["Key ~"]),
  1: Number(Yanfly.Parameters["Key 1"]),
  2: Number(Yanfly.Parameters["Key 2"]),
  3: Number(Yanfly.Parameters["Key 3"]),
  4: Number(Yanfly.Parameters["Key 4"]),
  5: Number(Yanfly.Parameters["Key 5"]),
  6: Number(Yanfly.Parameters["Key 6"]),
  7: Number(Yanfly.Parameters["Key 7"]),
  8: Number(Yanfly.Parameters["Key 8"]),
  9: Number(Yanfly.Parameters["Key 9"]),
  0: Number(Yanfly.Parameters["Key 0"]),
  minus: Number(Yanfly.Parameters["Key -"]),
  equal: Number(Yanfly.Parameters["Key ="]),

  q: Number(Yanfly.Parameters["Key Q (PageUp)"]),
  w: Number(Yanfly.Parameters["Key W (PageDown)"]),
  e: Number(Yanfly.Parameters["Key E"]),
  r: Number(Yanfly.Parameters["Key R"]),
  t: Number(Yanfly.Parameters["Key T"]),
  y: Number(Yanfly.Parameters["Key Y"]),
  u: Number(Yanfly.Parameters["Key U"]),
  i: Number(Yanfly.Parameters["Key I"]),
  o: Number(Yanfly.Parameters["Key O"]),
  p: Number(Yanfly.Parameters["Key P"]),
  foreBrack: Number(Yanfly.Parameters["Key ["]),
  backBrack: Number(Yanfly.Parameters["Key ]"]),
  backSlash: Number(Yanfly.Parameters["Key \\"]),

  a: Number(Yanfly.Parameters["Key A"]),
  s: Number(Yanfly.Parameters["Key S"]),
  d: Number(Yanfly.Parameters["Key D"]),
  f: Number(Yanfly.Parameters["Key F"]),
  g: Number(Yanfly.Parameters["Key G"]),
  h: Number(Yanfly.Parameters["Key H"]),
  j: Number(Yanfly.Parameters["Key J"]),
  k: Number(Yanfly.Parameters["Key K"]),
  l: Number(Yanfly.Parameters["Key L"]),
  semicolon: Number(Yanfly.Parameters["Key ;"]),
  quote: Number(Yanfly.Parameters['Key "']),
  enter: Number(Yanfly.Parameters["Key Enter (OK)"]),

  keyShift: Number(Yanfly.Parameters["Key Shift (Dash)"]),
  z: Number(Yanfly.Parameters["Key Z (OK)"]),
  x: Number(Yanfly.Parameters["Key X (Cancel)"]),
  c: Number(Yanfly.Parameters["Key C"]),
  v: Number(Yanfly.Parameters["Key V"]),
  b: Number(Yanfly.Parameters["Key B"]),
  n: Number(Yanfly.Parameters["Key N"]),
  m: Number(Yanfly.Parameters["Key M"]),
  comma: Number(Yanfly.Parameters["Key ,"]),
  period: Number(Yanfly.Parameters["Key ."]),
  foreSlash: Number(Yanfly.Parameters["Key /"]),

  space: Number(Yanfly.Parameters["Key Space (OK)"]),
  dirLeft: Number(Yanfly.Parameters["Key Left (Left)"]),
  dirUp: Number(Yanfly.Parameters["Key Up (Up)"]),
  dirRight: Number(Yanfly.Parameters["Key Right (Right)"]),
  dirDown: Number(Yanfly.Parameters["Key Down (Down)"]),
  ins: Number(Yanfly.Parameters["Key Insert (Cancel)"]),
  del: Number(Yanfly.Parameters["Key Delete"]),
  home: Number(Yanfly.Parameters["Key Home"]),
  end: Number(Yanfly.Parameters["Key End"]),
  pageUp: Number(Yanfly.Parameters["Key Page Up (PageUp)"]),
  pageDown: Number(Yanfly.Parameters["Key Page Down (PageDown)"]),

  num0: Number(Yanfly.Parameters["Key NumPad 0 (Cancel)"]),
  num1: Number(Yanfly.Parameters["Key NumPad 1"]),
  num2: Number(Yanfly.Parameters["Key NumPad 2 (Down)"]),
  num3: Number(Yanfly.Parameters["Key NumPad 3"]),
  num4: Number(Yanfly.Parameters["Key NumPad 4 (Left)"]),
  num5: Number(Yanfly.Parameters["Key NumPad 5"]),
  num6: Number(Yanfly.Parameters["Key NumPad 6 (Right)"]),
  num7: Number(Yanfly.Parameters["Key NumPad 7"]),
  num8: Number(Yanfly.Parameters["Key NumPad 8 (Up)"]),
  num9: Number(Yanfly.Parameters["Key NumPad 9"]),
  numPeriod: Number(Yanfly.Parameters["Key NumPad ."]),
  numPlus: Number(Yanfly.Parameters["Key NumPad +"]),
  numMinus: Number(Yanfly.Parameters["Key NumPad -"]),
  numTimes: Number(Yanfly.Parameters["Key NumPad *"]),
  numDivide: Number(Yanfly.Parameters["Key NumPad /"]),
};
Yanfly.Param.Variables = String(Yanfly.Parameters["Variables"]);

//=============================================================================
// Input Key Mapper
//=============================================================================

if (Yanfly.Param.BCEList["tilde"] !== 0) Input.keyMapper[192] = "tilde";
if (Yanfly.Param.BCEList["1"] !== 0) Input.keyMapper[49] = "1";
if (Yanfly.Param.BCEList["2"] !== 0) Input.keyMapper[50] = "2";
if (Yanfly.Param.BCEList["3"] !== 0) Input.keyMapper[51] = "3";
if (Yanfly.Param.BCEList["4"] !== 0) Input.keyMapper[52] = "4";
if (Yanfly.Param.BCEList["5"] !== 0) Input.keyMapper[53] = "5";
if (Yanfly.Param.BCEList["6"] !== 0) Input.keyMapper[54] = "6";
if (Yanfly.Param.BCEList["7"] !== 0) Input.keyMapper[55] = "7";
if (Yanfly.Param.BCEList["8"] !== 0) Input.keyMapper[56] = "8";
if (Yanfly.Param.BCEList["9"] !== 0) Input.keyMapper[57] = "9";
if (Yanfly.Param.BCEList["0"] !== 0) Input.keyMapper[48] = "0";
if (Yanfly.Param.BCEList["minus"] !== 0) Input.keyMapper[189] = "minus";
if (Yanfly.Param.BCEList["equal"] !== 0) Input.keyMapper[187] = "equal";

if (Yanfly.Param.BCEList["q"] !== 0) Input.keyMapper[81] = "q";
if (Yanfly.Param.BCEList["w"] !== 0) Input.keyMapper[87] = "w";
if (Yanfly.Param.BCEList["e"] !== 0) Input.keyMapper[69] = "e";
if (Yanfly.Param.BCEList["r"] !== 0) Input.keyMapper[82] = "r";
if (Yanfly.Param.BCEList["t"] !== 0) Input.keyMapper[84] = "t";
if (Yanfly.Param.BCEList["y"] !== 0) Input.keyMapper[89] = "y";
if (Yanfly.Param.BCEList["u"] !== 0) Input.keyMapper[85] = "u";
if (Yanfly.Param.BCEList["i"] !== 0) Input.keyMapper[73] = "i";
if (Yanfly.Param.BCEList["o"] !== 0) Input.keyMapper[79] = "o";
if (Yanfly.Param.BCEList["p"] !== 0) Input.keyMapper[80] = "p";
if (Yanfly.Param.BCEList["foreBrack"] !== 0) Input.keyMapper[219] = "foreBrack";
if (Yanfly.Param.BCEList["backBrack"] !== 0) Input.keyMapper[221] = "backBrack";
if (Yanfly.Param.BCEList["backSlash"] !== 0) Input.keyMapper[220] = "backSlash";

if (Yanfly.Param.BCEList["a"] !== 0) Input.keyMapper[65] = "a";
if (Yanfly.Param.BCEList["s"] !== 0) Input.keyMapper[83] = "s";
if (Yanfly.Param.BCEList["d"] !== 0) Input.keyMapper[68] = "d";
if (Yanfly.Param.BCEList["f"] !== 0) Input.keyMapper[70] = "f";
if (Yanfly.Param.BCEList["g"] !== 0) Input.keyMapper[71] = "g";
if (Yanfly.Param.BCEList["h"] !== 0) Input.keyMapper[72] = "h";
if (Yanfly.Param.BCEList["j"] !== 0) Input.keyMapper[74] = "j";
if (Yanfly.Param.BCEList["k"] !== 0) Input.keyMapper[75] = "k";
if (Yanfly.Param.BCEList["l"] !== 0) Input.keyMapper[76] = "l";
if (Yanfly.Param.BCEList["semicolon"] !== 0) Input.keyMapper[186] = "semicolon";
if (Yanfly.Param.BCEList["quote"] !== 0) Input.keyMapper[222] = "quote";
if (Yanfly.Param.BCEList["enter"] !== 0) Input.keyMapper[13] = "enter";

if (Yanfly.Param.BCEList["keyShift"] !== 0) Input.keyMapper[16] = "keyShift";
if (Yanfly.Param.BCEList["z"] !== 0) Input.keyMapper[90] = "z";
if (Yanfly.Param.BCEList["x"] !== 0) Input.keyMapper[88] = "x";
if (Yanfly.Param.BCEList["c"] !== 0) Input.keyMapper[67] = "c";
if (Yanfly.Param.BCEList["v"] !== 0) Input.keyMapper[86] = "v";
if (Yanfly.Param.BCEList["b"] !== 0) Input.keyMapper[66] = "b";
if (Yanfly.Param.BCEList["n"] !== 0) Input.keyMapper[78] = "n";
if (Yanfly.Param.BCEList["m"] !== 0) Input.keyMapper[77] = "m";
if (Yanfly.Param.BCEList["comma"] !== 0) Input.keyMapper[188] = "comma";
if (Yanfly.Param.BCEList["period"] !== 0) Input.keyMapper[190] = "period";
if (Yanfly.Param.BCEList["foreSlash"] !== 0) Input.keyMapper[191] = "foreSlash";

if (Yanfly.Param.BCEList["space"] !== 0) Input.keyMapper[32] = "space";
if (Yanfly.Param.BCEList["dirLeft"] !== 0) Input.keyMapper[37] = "dirLeft";
if (Yanfly.Param.BCEList["dirUp"] !== 0) Input.keyMapper[38] = "dirUp";
if (Yanfly.Param.BCEList["dirRight"] !== 0) Input.keyMapper[39] = "dirRight";
if (Yanfly.Param.BCEList["dirDown"] !== 0) Input.keyMapper[40] = "dirDown";
if (Yanfly.Param.BCEList["ins"] !== 0) Input.keyMapper[45] = "ins";
if (Yanfly.Param.BCEList["del"] !== 0) Input.keyMapper[46] = "del";
if (Yanfly.Param.BCEList["home"] !== 0) Input.keyMapper[36] = "home";
if (Yanfly.Param.BCEList["end"] !== 0) Input.keyMapper[35] = "end";
if (Yanfly.Param.BCEList["pageUp"] !== 0) Input.keyMapper[33] = "pageUp";
if (Yanfly.Param.BCEList["pageDown"] !== 0) Input.keyMapper[34] = "pageDown";

if (Yanfly.Param.BCEList["num0"] !== 0) Input.keyMapper[96] = "num0";
if (Yanfly.Param.BCEList["num1"] !== 0) Input.keyMapper[97] = "num1";
if (Yanfly.Param.BCEList["num2"] !== 0) Input.keyMapper[98] = "num2";
if (Yanfly.Param.BCEList["num3"] !== 0) Input.keyMapper[99] = "num3";
if (Yanfly.Param.BCEList["num4"] !== 0) Input.keyMapper[100] = "num4";
if (Yanfly.Param.BCEList["num5"] !== 0) Input.keyMapper[101] = "num5";
if (Yanfly.Param.BCEList["num6"] !== 0) Input.keyMapper[102] = "num6";
if (Yanfly.Param.BCEList["num7"] !== 0) Input.keyMapper[103] = "num7";
if (Yanfly.Param.BCEList["num8"] !== 0) Input.keyMapper[104] = "num8";
if (Yanfly.Param.BCEList["num9"] !== 0) Input.keyMapper[105] = "num9";
if (Yanfly.Param.BCEList["numPeriod"] !== 0) Input.keyMapper[110] = "numPeriod";
if (Yanfly.Param.BCEList["numPlus"] !== 0) Input.keyMapper[107] = "numPlus";
if (Yanfly.Param.BCEList["numMinus"] !== 0) Input.keyMapper[109] = "numMinus";
if (Yanfly.Param.BCEList["numTimes"] !== 0) Input.keyMapper[106] = "numTimes";
if (Yanfly.Param.BCEList["numDivide"] !== 0) Input.keyMapper[111] = "numDivide";

//=============================================================================
// Input
//=============================================================================

Input._revertButton = function (button) {
  if (button === "OK") {
    this.keyMapper[13] = "ok";
    this.keyMapper[32] = "ok";
    this.keyMapper[90] = "ok";
  } else if (button === "CANCEL") {
    this.keyMapper[45] = "escape";
    this.keyMapper[88] = "escape";
    this.keyMapper[96] = "escape";
  } else if (button === "DASH") {
    this.keyMapper[16] = "shift";
  } else if (button === "PAGEUP") {
    this.keyMapper[33] = "pageup";
    this.keyMapper[81] = "pageup";
  } else if (button === "PAGEDOWN") {
    this.keyMapper[34] = "pagedown";
    this.keyMapper[87] = "pagedown";
  } else if (button === "LEFT") {
    this.keyMapper[37] = "left";
    this.keyMapper[100] = "left";
  } else if (button === "UP") {
    this.keyMapper[38] = "up";
    this.keyMapper[104] = "up";
  } else if (button === "RIGHT") {
    this.keyMapper[39] = "right";
    this.keyMapper[102] = "right";
  } else if (button === "DOWN") {
    this.keyMapper[40] = "down";
    this.keyMapper[98] = "down";
  } else if (button === "ALL") {
    this.keyMapper[13] = "ok";
    this.keyMapper[32] = "ok";
    this.keyMapper[90] = "ok";
    this.keyMapper[45] = "escape";
    this.keyMapper[88] = "escape";
    this.keyMapper[96] = "escape";
    this.keyMapper[16] = "shift";
    this.keyMapper[33] = "pageup";
    this.keyMapper[81] = "pageup";
    this.keyMapper[34] = "pagedown";
    this.keyMapper[87] = "pagedown";
    this.keyMapper[37] = "left";
    this.keyMapper[100] = "left";
    this.keyMapper[38] = "up";
    this.keyMapper[104] = "up";
    this.keyMapper[39] = "right";
    this.keyMapper[102] = "right";
    this.keyMapper[40] = "down";
    this.keyMapper[98] = "down";
  }
};

Input._switchButton = function (button) {
  if (button === "OK") {
    if (Yanfly.Param.BCEList["enter"] !== 0) this.keyMapper[13] = "enter";
    if (Yanfly.Param.BCEList["space"] !== 0) this.keyMapper[32] = "space";
    if (Yanfly.Param.BCEList["z"] !== 0) this.keyMapper[90] = "z";
  } else if (button === "CANCEL") {
    if (Yanfly.Param.BCEList["ins"] !== 0) this.keyMapper[45] = "ins";
    if (Yanfly.Param.BCEList["x"] !== 0) this.keyMapper[88] = "x";
    if (Yanfly.Param.BCEList["num0"] !== 0) this.keyMapper[96] = "num0";
  } else if (button === "DASH") {
    if (Yanfly.Param.BCEList["keyShift"] !== 0) this.keyMapper[16] = "keyShift";
  } else if (button === "PAGEUP") {
    if (Yanfly.Param.BCEList["pageUp"] !== 0) this.keyMapper[33] = "pageUp";
    if (Yanfly.Param.BCEList["q"] !== 0) this.keyMapper[81] = "q";
  } else if (button === "PAGEDOWN") {
    if (Yanfly.Param.BCEList["pageDown"] !== 0) this.keyMapper[34] = "pageDown";
    if (Yanfly.Param.BCEList["w"] !== 0) this.keyMapper[87] = "w";
  } else if (button === "LEFT") {
    if (Yanfly.Param.BCEList["dirLeft"] !== 0) this.keyMapper[37] = "dirLeft";
    if (Yanfly.Param.BCEList["num4"] !== 0) this.keyMapper[100] = "num4";
  } else if (button === "UP") {
    if (Yanfly.Param.BCEList["dirUp"] !== 0) this.keyMapper[38] = "dirUp";
    if (Yanfly.Param.BCEList["num8"] !== 0) this.keyMapper[104] = "num8";
  } else if (button === "RIGHT") {
    if (Yanfly.Param.BCEList["dirRight"] !== 0) this.keyMapper[39] = "dirRight";
    if (Yanfly.Param.BCEList["num6"] !== 0) this.keyMapper[102] = "num6";
  } else if (button === "DOWN") {
    if (Yanfly.Param.BCEList["dirDown"] !== 0) this.keyMapper[40] = "dirDown";
    if (Yanfly.Param.BCEList["num2"] !== 0) this.keyMapper[98] = "num2";
  } else if (button === "ALL") {
    if (Yanfly.Param.BCEList["enter"] !== 0) this.keyMapper[13] = "enter";
    if (Yanfly.Param.BCEList["space"] !== 0) this.keyMapper[32] = "space";
    if (Yanfly.Param.BCEList["z"] !== 0) this.keyMapper[90] = "z";
    if (Yanfly.Param.BCEList["ins"] !== 0) this.keyMapper[45] = "ins";
    if (Yanfly.Param.BCEList["x"] !== 0) this.keyMapper[88] = "x";
    if (Yanfly.Param.BCEList["num0"] !== 0) this.keyMapper[96] = "num0";
    if (Yanfly.Param.BCEList["keyShift"] !== 0) this.keyMapper[16] = "keyShift";
    if (Yanfly.Param.BCEList["pageUp"] !== 0) this.keyMapper[33] = "pageUp";
    if (Yanfly.Param.BCEList["q"] !== 0) this.keyMapper[81] = "q";
    if (Yanfly.Param.BCEList["pageDown"] !== 0) this.keyMapper[34] = "pageDown";
    if (Yanfly.Param.BCEList["w"] !== 0) this.keyMapper[87] = "w";
    if (Yanfly.Param.BCEList["dirLeft"] !== 0) this.keyMapper[37] = "dirLeft";
    if (Yanfly.Param.BCEList["num4"] !== 0) this.keyMapper[100] = "num4";
    if (Yanfly.Param.BCEList["dirUp"] !== 0) this.keyMapper[38] = "dirUp";
    if (Yanfly.Param.BCEList["num8"] !== 0) this.keyMapper[104] = "num8";
    if (Yanfly.Param.BCEList["dirRight"] !== 0) this.keyMapper[39] = "dirRight";
    if (Yanfly.Param.BCEList["num6"] !== 0) this.keyMapper[102] = "num6";
    if (Yanfly.Param.BCEList["dirDown"] !== 0) this.keyMapper[40] = "dirDown";
    if (Yanfly.Param.BCEList["num2"] !== 0) this.keyMapper[98] = "num2";
  }
};

//=============================================================================
// Scene_Base
//=============================================================================

Yanfly.BCE.Scene_Base_start = Scene_Base.prototype.start;
Scene_Base.prototype.start = function () {
  Yanfly.BCE.Scene_Base_start.call(this);
  Input._revertButton("ALL");
};

//=============================================================================
// Scene_Map
//=============================================================================

Yanfly.BCE.Scene_Map_start = Scene_Map.prototype.start;
Scene_Map.prototype.start = function () {
  Yanfly.BCE.Scene_Map_start.call(this);
  Input._switchButton("ALL");
};

Yanfly.BCE.Scene_Map_updateScene = Scene_Map.prototype.updateScene;
Scene_Map.prototype.updateScene = function () {
  Yanfly.BCE.Scene_Map_updateScene.call(this);
  if (SceneManager.isSceneChanging()) return;
  if ($gameMap.isEventRunning()) return;
  this.updateButtonEvents();
};

Scene_Map.prototype.updateButtonEvents = function () {
  for (var key in Yanfly.Param.BCEList) {
    var eventId = Yanfly.Param.BCEList[key];
    if (eventId <= 0) continue;
    if (!Input.isRepeated(key)) continue;
    $gameTemp.reserveCommonEvent(eventId);
    break;
  }
};

//=============================================================================
// Game_Interpreter
//=============================================================================

Yanfly.BCE.Game_Interpreter_pluginCommand =
  Game_Interpreter.prototype.pluginCommand;
Game_Interpreter.prototype.pluginCommand = function (command, args) {
  Yanfly.BCE.Game_Interpreter_pluginCommand.call(this, command, args);
  if (command === "RevertButton") this.revertButton(args);
  if (command === "SwitchButton") this.switchButton(args);
  if (command === "TriggerButton") this.triggerButton(args);
};

Game_Interpreter.prototype.revertButton = function (args) {
  if (!args) return;
  var button = args[0].toUpperCase();
  Input._revertButton(button);
};

Game_Interpreter.prototype.switchButton = function (args) {
  if (!args) return;
  var button = args[0].toUpperCase();
  Input._switchButton(button);
};

Game_Interpreter.prototype.triggerButton = function (args) {
  if (!args) return;
  var button = args[0].toLowerCase();
  if (button === "cancel") button = "escape";
  if (button === "dash") button = "shift";
  Input._latestButton = button;
  Input._pressedTime = 0;
};

//=============================================================================
// End of File
//=============================================================================
